;; Arduino LCD Library
;; microscheme.org

(define lcdpins (vector 4 5 6 7 8 9))
;; lcdpins: d0 d1 d2 d3 rs en

(define (pulse)
	(set-pin (vector-ref lcdpins 5) #f)
	(micropause 1)
	(set-pin (vector-ref lcdpins 5) #t)
	(micropause 1)
	(set-pin (vector-ref lcdpins 5) #f)
	(micropause 1))

(define (write4bits val)
	(set-pin (vector-ref lcdpins 0) (not (zero? (mod val 2))))
	(set-pin (vector-ref lcdpins 1) (not (zero? (mod (div val 2) 2))))
	(set-pin (vector-ref lcdpins 2) (not (zero? (mod (div val 4) 2))))
	(set-pin (vector-ref lcdpins 3) (not (zero? (mod (div val 8) 2))))
	(pulse))

(define (send val mode)
	(set-pin (vector-ref lcdpins 4) mode)
	(write4bits (div val 16))
	(write4bits val))

(define (lcd_init)
	(for-each-vector (lambda (pin) (set-ddr pin #t)) lcdpins)
	(pause 50)
	(set-pin (vector-ref lcdpins 4) #f)
	(set-pin (vector-ref lcdpins 5) #f)
	(write4bits 3)
	(pause 5)
	(write4bits 3)
	(pause 5)
	(write4bits 3)
	(pause 5)
	(write4bits 2)
	(send 40 #f)
	(send 12 #f)
	(send 1 #f)
	(pause 2)
	(send 6 #f)
	(send 128 #f))

(define (write val)
	(send (if (char? val) (char->number val) val) #t))

(define (set-cursor row col)
	(send (+ 128 (+ col (* 64 row))) #f))