;; Ryan Suchocki
;; microscheme.org

(include "libraries/list.ms")

(define (fibstep i acc n2 n1)
	(if (= 0 i)
		acc
		(fibstep (- i 1) (cons (+ n2 n1) acc) n1 (+ n2 n1))))

(define (fib n)
	 (reverse (fibstep n () 0 1)))

(define (factorial n)
	(if (zero? n)
		(begin (serial-send (stacksize)) 1)
		(* n (factorial (- n 1)))))

(define (tfactorial n acc)
	(if (zero? n)
		(begin (serial-send (stacksize)) acc)
		(tfactorial (- n 1) (* n acc))))

; Tail Recursion Demo

;	(serial-send (factorial 7))
;	(serial-send (tfactorial 7 1))

; List Processing Demo

;	(define myList (list 7 8 9 13))
;	(for-each (lambda (i) (serial-send i)) myList)
;	(for-each (lambda (i) (serial-send i)) (reverse myList))

; List Size Demo

;	(serial-send (div (+ (stacksize) (heapsize)) 82))
;	(serial-send (car (reverse (reverse (reverse (reverse (reverse (reverse (vector->list arduino_ports)))))))))
;	(serial-send (div (+ (stacksize) (heapsize)) 82))

; Closure Demo

;	(define counter 
;		(lambda (x)
;			(lambda () (set! x (+ x 1)) x)))

;	(define myCounter (counter 10))
;	(serial-send (myCounter))
;	(serial-send (myCounter))
;	(serial-send (myCounter))
