;; Arduino Digital I/O Library
;; microscheme.org

;; Pin mappings for the Arduino UNO
(define arduino_ports	(vector 41 41 41 41 41 41 41 41 35 35 35 35 35 35))
(define arduino_pins	(vector 1  2  4  8  16 32 64 128 1 2  4  8  16 32))

(define set-ddr (lambda (apin val)
	(set-digital-state (+ 1 (vector-ref arduino_ports apin)) (vector-ref arduino_pins apin) val)))
(define set-pin (lambda (apin val)
	(set-digital-state (+ 2 (vector-ref arduino_ports apin)) (vector-ref arduino_pins apin) val)))
(define get-ddr (lambda (apin)
	(digital-state (+ 1 (vector-ref arduino_ports apin)) (vector-ref arduino_pins apin))))
(define get-pin (lambda (apin)
	(digital-state (vector-ref arduino_ports apin) (vector-ref arduino_pins apin))))

(define (input p) (set-ddr p #f))
(define (output p) (set-ddr p #t))
(define (low p) (set-pin p #f))
(define (high p) (set-pin p #t))
