;; Boilerplate stuff for the Arduino Mega (2560)
;; CPU: ATMega2560


;; Stack Pointers:

.EQU	SPl,	0x3D
.EQU	SPh,	0x3E

;; RAM Helpers
.EQU	RAM,	0x200
.EQU	RAMEND,	0x21FF

;; Short-Range Data Ports:

.EQU	PINA,	0x00
.EQU	DDRA,	0x01
.EQU	PORTA,	0x02
.EQU	PINB,	0x03
.EQU	DDRB,	0x04
.EQU	PORTB,	0x05
.EQU	PINC,	0x06
.EQU	DDRC,	0x07
.EQU	PORTC,	0x08
.EQU	PIND,	0x09
.EQU	DDRD,	0x0A
.EQU	PORTD,	0x0B
.EQU	PINE,	0x0C
.EQU	DDRE,	0x0D
.EQU	PORTE,	0x0E
.EQU	PINF,	0x0F
.EQU	DDRF,	0x10
.EQU	PORTF,	0x11
.EQU	PING,	0x12
.EQU	DDRG,	0x13
.EQU	PORTG,	0x14

;; Data-Port Memory Map Addresses
.EQU	mPINA,	0x20
.EQU	mDDRA,	0x21
.EQU	mPORTA,	0x22
.EQU	mPINB,	0x23
.EQU	mDDRB,	0x24
.EQU	mPORTB,	0x25
.EQU	mPINC,	0x26
.EQU	mDDRC,	0x27
.EQU	mPORTC,	0x28
.EQU	mPIND,	0x29
.EQU	mDDRD,	0x2A
.EQU	mPORTD,	0x2B
.EQU	mPINE,	0x2C
.EQU	mDDRE,	0x2D
.EQU	mPORTE,	0x2E
.EQU	mPINF,	0x2F
.EQU	mDDRF,	0x30
.EQU	mPORTF,	0x31
.EQU	mPING,	0x32
.EQU	mDDRG,	0x33
.EQU	mPORTG,	0x34
.EQU	mPINH,	0x100
.EQU	mDDRH,	0x101
.EQU	mPORTH,	0x102
.EQU	mPINJ,	0x103
.EQU	mDDRJ,	0x104
.EQU	mPORTJ,	0x105
.EQU	mPINK,	0x106
.EQU	mDDRK,	0x107
.EQU	mPORTK,	0x108
.EQU	mPINL,	0x109
.EQU	mDDRL,	0x10A
.EQU	mPORTL,	0x10B

;; Registers:

; only registers 16 and above allow constant setting via LDI


;; 16-bit counting registers, of wich XYZ are 
;; are memory address registers.
.EQU	WL,	0x18
.EQU	WH,	0x19
.EQU	XL,	0x1A
.EQU	XH,	0x1B
.EQU	YL,	0x1C
.EQU	YH,	0x1D
.EQU 	ZL,	0x1E
.EQU	ZH,	0x1F







.EQU	PORT13,	PORTB
.EQU	DDR13,	DDRB
.EQU	PIN13,	PINB
.EQU	P13,	7

.EQU	mPORT13,	mPORTB
.EQU	mDDR13,	mDDRB
.EQU	mPIN13,	mPINB
.EQU	mP13,	0b10000000






.EQU	UDR0,	0xC6
.EQU	UBRR0H,	0xC5
.EQU	UBRR0L,	0xC4
.EQU	UCSR0C,	0xC2
.EQU	UCSR0B,	0xC1
.EQU	UCSR0A,	0xC0

.EQU	UDR1,	0xCE
.EQU	UBRR1H,	0xCD
.EQU	UBRR1L,	0xCC
.EQU	UCSR1C,	0xCA
.EQU	UCSR1B,	0xC9
.EQU	UCSR1A,	0xC8

.EQU	UDRE0,	5		; Transmit Buffer Empty
.EQU	TXC0,	6		; TX Complete
.EQU	RXC0,	7		; RX Complete

.EQU	TXENm,	0x08;
.EQU	RXENm,	0x10;

.EQU	BAUD_9600, 103



