;; Arduino Digital I/O Library
;; microscheme.org

;; Pin mappings for the Arduino MEGA
(define arduino_ports	(vector 44 44 44 44 50 44 256 256 256 256 35 35 35 35 265 265 256 256 38 38 38 38 32 32 32 32 32 
							32 32 32 38 38 38 38 38 38 38 38 38 50 50 50 265 265 265 265 265 265 265 265 35 35 35 35))
(define arduino_pins	(vector 1 2 16 32 32 8 8 16 32 64 16 32 64 128 2 1 2 1 8 4 2 1 1 2 4 8 16 32 64 128 128 64 32 16 
	  						8 4 2 1 128 4 2 1 128 64 32 16 8 4 2 1 8 4 2 1 1 2 4 8 16 32 64 128 1 2 4 8 16 32 64 128))


(define set-ddr (lambda (apin val)
	(set-digital-state (+ 1 (vector-ref arduino_ports apin)) (vector-ref arduino_pins apin) val)))

(define set-pin (lambda (apin val)
	(set-digital-state (+ 2 (vector-ref arduino_ports apin)) (vector-ref arduino_pins apin) val)))

(define get-ddr (lambda (apin)
	(digital-state (+ 1 (vector-ref arduino_ports apin)) (vector-ref arduino_pins apin))))
	
(define get-pin (lambda (apin)
	(digital-state (vector-ref arduino_ports apin) (vector-ref arduino_pins apin))))

(define (input p) (set-ddr p #f))
(define (output p) (set-ddr p #t))
(define (low p) (set-pin p #f))
(define (high p) (set-pin p #t))
